<?php
add_action( 'gform_field_standard_settings', 'GFDS_settings', 10, 2 );
function GFDS_settings( $position, $form_id ) {
    
    if ($position == 5) {
    ?>
    <li class="signature_notice field_setting">
        <label for="signature_notice" class="section_label"><?php  echo esc_html( __( 'Write A Note :', 'gravity-forms-digital-signature' ) );?></label>
        <textarea id="signature_notice" name="Write A Note :" onchange="SetFieldProperty('signature_notice', this.value);"></textarea>
    </li>

    <li class="pad_width field_setting">
        <label for="pad_width" class="section_label">
               <?php esc_html_e('Signature Pad width :', 'gravity-forms-digital-signature'); ?>
        </label>
        <input type="number" id="pad_width"  name="pad_width"  onchange="SetFieldProperty('pad_width', this.value);"/>
    </li>

    <li class="pad_height field_setting">
        <label for="pad_height" class="section_label">
               <?php esc_html_e('Signature Pad Height :', 'gravity-forms-digital-signature'); ?>
        </label>
        <input type="number" id="pad_height"  name="pad_height"  onchange="SetFieldProperty('pad_height', this.value);"/>
    </li>

    <li class="pad_back_color field_setting">
        <label for="pad_back_color" class="section_label"><?php  echo esc_html( __( 'Signature Pad Background Color', 'gravity-forms-digital-signature' ) );?></label>
        <input type="color" id="pad_back_color" name="Pad Background Color" onchange="SetFieldProperty('pad_back_color', this.value);"/>
    </li>

    <li class="pad_pen_color field_setting">
        <label for="pad_pen_color" class="section_label"><?php  echo esc_html( __( 'Signature Pad Pen Color', 'gravity-forms-digital-signature' ) );?></label>
        <input type="color" id="pad_pen_color" name="Pad Pen Color" onchange="SetFieldProperty('pad_pen_color', this.value);"/>
    </li>

   <?php
    }
}


/* editor js script*/
add_action('gform_editor_js', 'signature_GF_editor_script', 11, 2);
function signature_GF_editor_script() {?>
    <script type='text/javascript'>
    jQuery(document).ready(function($) {
        jQuery(document).bind("gform_load_field_settings", function(event, field, form){
            jQuery("#signature_notice").val(field["signature_notice"]);
            jQuery("#pad_width").val(field["pad_width"]);
            jQuery("#pad_height").val(field["pad_height"]);
            jQuery("#pad_back_color").val(field["pad_back_color"]);
            jQuery("#pad_pen_color").val(field["pad_pen_color"]);
        });
        
    });
    </script>
    <?php
}


/*default value add */
add_action( 'gform_editor_js_set_default_values', 'GFDS_default_values' );
function GFDS_default_values(){
    ?>
   
    case "Signature" :
        field.label = "Digital Signature";
        field.signature_notice = "Rate Us";
        field.pad_width = 300;
        field.pad_height = 200;
        field.pad_back_color = "#d1d1d1";
        field.pad_pen_color = "#000000";
        
    break;
    
    <?php
}


/* Gravity form class here */
if (class_exists('GF_Field')) {
    class GFDS_Digital_Signature extends GF_Field {

        public $type = 'Signature';

        public function get_form_editor_field_title() { return esc_attr__( 'Signature', 'gravity-forms-digital-signature' ); }

        public function get_form_editor_button() {
            return array(
                'group' => 'advanced_fields',
                'text'  => $this->get_form_editor_field_title(),
            );
        }

        /* Gravity form editor setting */
        function get_form_editor_field_settings() {
            return array(
                'label_setting',
                'signature_notice',
                'pad_width',
                'pad_height',
                'pad_back_color',
                'pad_pen_color',
            );
        }

        function is_conditional_logic_supported() { return true; }

        function get_value_submission( $field_values, $get_from_post=true ) {
            if(!$get_from_post) {
                return $field_values;
            }
            return sanitize_text_field($_POST);
        } 

        /*Field value set here */
        function get_field_input( $form, $value = '', $entry = null ) {

            if ($this->is_form_editor()) {
                return '<div class="gfds_cust_msg">this is signature field.</div>'.$this->signature_notice;;
            }

            $form_id         = $form['id'];
            $is_entry_detail = $this->is_entry_detail();
            $is_form_editor  = $this->is_form_editor();
            $id              = intval($this->id);
            $field_id        = $is_entry_detail || $is_form_editor || $form_id == 0 ? "input_$id" : 'input_' . $form_id . "_$id";
            $atts['type']    = 'hidden';
            $label2          = $this->label;
            $label           = str_replace(' ','-',$label2);
            $lables          = '#'.$label.'';
            $signature_notice  = $this->signature_notice;
            $pad_width       = $this->pad_width;
            $pad_height      = $this->pad_height;
            $pad_back_color  = $this->pad_back_color;
            $pad_pen_color   = $this->pad_pen_color;


            $html = '';

            $html .= '<div class="ginput_container" id="signature_id_'.$id.'">';
            $html .= '<div class="digi_signature_class">';
            $html .= '<canvas id="gfds_signature" name="input_'.$id.'" class="signature-pad" width="'.$pad_width.'" height="'.$pad_height.'" pad_back_color="'.$pad_back_color.'" pad_pen_color="'.$pad_pen_color.'"></canvas>';  
            $html .= '<input id="clear" name="clear_data" class="clearButton" type="button" data-action="clear" value="Clear" style="display: flex;">';
            $html .= '<input class="custom_signature '.$label.'" type="hidden" name="input_'.$id.'" id="'.$id.'" value="">';
            $html .= '</div>';  
            $html .= '</div>';  
            $html .= '<span  class="gfds-form-control-wrap_'.$label.'">';  
            $html .= '<div class="gfds_notice">';
            $html .= $signature_notice;
            $html .= '</div>';
            $html .= '</span>'; 
        
            return $html;
            
        }

        public function get_value_entry_list( $value, $entry, $field_id, $columns, $form ) {

            list( $url, $alt ) = rgexplode( '|:|', $value, 2 );

            if ( ! empty( $url ) ) {
                $thumb = GFEntryList::get_icon_url('/images/doctypes/icon_image.gif');
                $value = "<a href='" . esc_attr( $url ) . "' target='_blank' aria-label='" . esc_attr__( 'View the image', 'gravity-forms-digital-signature' ) . "'><img src='$thumb' alt='$alt' /></a>";
            }
            return $value;
        }

        public function get_value_entry_detail( $value, $currency = '', $use_text = false, $format = 'html', $media = 'screen' ) {

            $ary         = explode( '|:|', $value );
            $url         = count( $ary ) > 0 ? $ary[0] : '';
            $alt         = count( $ary ) > 1 ? $ary[1] : '';

            if ( ! empty( $value ) ) {
                $url = str_replace( ' ', '%20', $url );
                switch ( $format ) {
                    case 'text' :
                        $value = $url;
                        break;

                    default :
                        $value = "<a href='$value' target='_blank' aria-label='" . esc_attr__( 'View the image', 'gravity-forms-digital-signature' ) . "'><img src='$url' width='100' alt='$alt' /></a>";
                       

                    break;
                }
            }
            return $value;
        }

        public function get_value_merge_tag( $value, $input_id, $entry, $form, $modifier, $raw_value, $url_encode, $esc_html, $format, $nl2br ) {
            list( $url, $alt ) = array_pad( explode( '|:|', $value ), 2, false );
            switch ( $modifier ) {
                case 'alt' :
                    return $alt;

                default :
                    return str_replace( ' ', '%20', $url );
            }
        }


        public function get_value_save_entry( $value, $form, $input_name, $lead_id, $lead ){
            // echo "<pre>";
            // print_r($value);
            // echo "</pre>";

            $abs_field = $form['fields'];
            
            foreach( $abs_field as $field ){
    
                if( $field->type == 'Signature' ){

                    $signature_id = $field['id'];

                    $input_id = $signature_id;

                    $title = 'abcd';

                    $upload_dir  = wp_upload_dir();
                    $upload_path = str_replace( '/', DIRECTORY_SEPARATOR, $upload_dir['path'] ) . DIRECTORY_SEPARATOR;
                    $img             = str_replace( 'data:image/png;base64,', '',  $value );
                    $img             = str_replace( ' ', '+', $img );
                    $decoded         = base64_decode( $img );
                    $filename        = $title.'.jpeg';
                    $file_type       = 'image/jpeg';
                    
                    $hashed_filename = md5( $filename . microtime() ) . '_' . $filename;
                    // $var_change = $_POST['input_1'] = ''.site_url().'/'.$hashed_filename.'';
                   
                    // Save the image in the uploads directory.
                    $upload_file = file_put_contents( $upload_path . $hashed_filename, $decoded );

                    $attachment = array(
                        'post_mime_type' => $file_type,
                        'post_title'     => preg_replace( '/\.[^.]+$/', '', basename( $hashed_filename ) ),
                        'post_content'   => '',
                        'post_status'    => 'inherit',
                        'guid'           => $upload_dir['url'] . '/' . basename( $hashed_filename )
                    );


                    $attach_id = wp_insert_attachment( $attachment, $upload_dir['path'] . '/' . $hashed_filename );
                    require_once( ABSPATH . 'wp-admin/includes/image.php' );
                    
                    $wp_get_attac = wp_get_attachment_url($attach_id, true);
                    $value = $wp_get_attac;
                    return $wp_get_attac;
                }
            }
        }

    }
    GF_Fields::register(new GFDS_Digital_Signature() );
}